/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.tables.records.VCoreUnitRecord;

import java.time.LocalDateTime;
import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VCoreUnit extends TableImpl<VCoreUnitRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.v_core_unit</code>
     */
    public static final VCoreUnit V_CORE_UNIT = new VCoreUnit();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VCoreUnitRecord> getRecordType() {
        return VCoreUnitRecord.class;
    }

    /**
     * The column <code>common_dd.v_core_unit.lastchange</code>.
     */
    public final TableField<VCoreUnitRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6), this, "");

    /**
     * The column <code>common_dd.v_core_unit.pk</code>.
     */
    public final TableField<VCoreUnitRecord, Integer> PK = createField(DSL.name("pk"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_core_unit.fk_trans_key</code>.
     */
    public final TableField<VCoreUnitRecord, String> FK_TRANS_KEY = createField(DSL.name("fk_trans_key"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_core_unit.unit</code>.
     */
    public final TableField<VCoreUnitRecord, String> UNIT = createField(DSL.name("unit"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_core_unit.is_format</code>.
     */
    public final TableField<VCoreUnitRecord, Boolean> IS_FORMAT = createField(DSL.name("is_format"), SQLDataType.BOOLEAN, this, "");

    /**
     * The column <code>common_dd.v_core_unit.de_de</code>.
     */
    public final TableField<VCoreUnitRecord, String> DE_DE = createField(DSL.name("de_de"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_core_unit.en</code>.
     */
    public final TableField<VCoreUnitRecord, String> EN = createField(DSL.name("en"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_core_unit.pl</code>.
     */
    public final TableField<VCoreUnitRecord, String> PL = createField(DSL.name("pl"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_core_unit.pt</code>.
     */
    public final TableField<VCoreUnitRecord, String> PT = createField(DSL.name("pt"), SQLDataType.CLOB, this, "");

    private VCoreUnit(Name alias, Table<VCoreUnitRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VCoreUnit(Name alias, Table<VCoreUnitRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        create view "v_core_unit" as  SELECT t_core_unit.lastchange,
         t_core_unit.pk,
         t_core_unit.fk_trans_key,
         t_core_unit.unit,
         t_core_unit.is_format,
         de.value AS de_de,
         en.value AS en,
         pl.value AS pl,
         pt.value AS pt
        FROM ((((common_dd.t_core_unit
          LEFT JOIN common_dd.t_core_translation de ON (((t_core_unit.fk_trans_key = de.fk_trans_key) AND (de.isocode = 'de_DE'::common_dd.enum_isocode) AND (de.category = 'crf'::common_dd.enum_trans_category))))
          LEFT JOIN common_dd.t_core_translation en ON (((t_core_unit.fk_trans_key = en.fk_trans_key) AND (en.isocode = 'en'::common_dd.enum_isocode) AND (en.category = 'crf'::common_dd.enum_trans_category))))
          LEFT JOIN common_dd.t_core_translation pl ON (((t_core_unit.fk_trans_key = pl.fk_trans_key) AND (pl.isocode = 'pl'::common_dd.enum_isocode) AND (pl.category = 'crf'::common_dd.enum_trans_category))))
          LEFT JOIN common_dd.t_core_translation pt ON (((t_core_unit.fk_trans_key = pt.fk_trans_key) AND (pt.isocode = 'pt_BR'::common_dd.enum_isocode) AND (pt.category = 'crf'::common_dd.enum_trans_category))));
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_core_unit</code> table reference
     */
    public VCoreUnit(String alias) {
        this(DSL.name(alias), V_CORE_UNIT);
    }

    /**
     * Create an aliased <code>common_dd.v_core_unit</code> table reference
     */
    public VCoreUnit(Name alias) {
        this(alias, V_CORE_UNIT);
    }

    /**
     * Create a <code>common_dd.v_core_unit</code> table reference
     */
    public VCoreUnit() {
        this(DSL.name("v_core_unit"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VCoreUnit as(String alias) {
        return new VCoreUnit(DSL.name(alias), this);
    }

    @Override
    public VCoreUnit as(Name alias) {
        return new VCoreUnit(alias, this);
    }

    @Override
    public VCoreUnit as(Table<?> alias) {
        return new VCoreUnit(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreUnit rename(String name) {
        return new VCoreUnit(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreUnit rename(Name name) {
        return new VCoreUnit(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreUnit rename(Table<?> name) {
        return new VCoreUnit(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreUnit where(Condition condition) {
        return new VCoreUnit(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreUnit where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreUnit where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreUnit where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreUnit where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreUnit where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreUnit where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreUnit where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreUnit whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreUnit whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
